PROGRAM Performance_Factor;{ver 1.0}

{
A Turbo Pascal version of a BASIC program written by Tom Caldwell, Assistant
Sysop ModelNet(CIS). The BASIC program is available in several formats in the
data libraries of ModelNet on Compuserve. Translated to Turbo Pascal by
Curtis W. Givens, Dayton, Ohio.
}


VAR

D,P:REAL; {Prop diameter and pitch}
R:REAL; {Engine RPM in thousands}
M:REAL; {Gross weight in ounces}
T:REAL; {Wing thickness % expressed as a decimal fraction}
E:REAL; {field elevation in feet MSL}
Perf_Fac:REAL;{performance factor}
Name:STRING[25]; {Name of plane}
WA:REAL; {Wing area in square inches}
WingType:INTEGER; {Wing type designator}
TY:INTEGER;

PROCEDURE Intro;

   BEGIN
     WRITELN('This program will ask for data about you airplane and flying');
     WRITELN('site after which it will perform a seris of calculation to');
     WRITELN('determine the plane''s theoretical performance factor and output');
     WRITELN('an estimate of the aircraft performance potential.');
     WRITELN;
     WRITE('Please input the name of the aircraft:');
     READLN(Name)
   END;{Intro}

PROCEDURE GetData;

   BEGIN
     CLRSCR;
     WRITELN('Please remember to use decimal fractions only.');
     WRITELN;
     WRITE('Prop diameter - inches?');
     READLN(D);
     WRITE('Prop pitch - inches?');
     READLN(P);
     WRITE('Engine RPM - 1000s?');
     READLN(R);
     WRITE('Gross weight in ounces?');
     READLN(M);
     WRITE('Wing thickness as a percentage of the chord ie 15%= 15?');
     READLN(T);
     WRITE('Field elevation - feet MSL?');
     READLN(E)
   END;{GetData}

PROCEDURE WingArea;

VAR
TipChord,RootChord,Span:REAL;
Answer:BOOLEAN;
X:INTEGER;

   BEGIN
     WRITELN('The wing area of the aircraft is required for the calculations.');
     WRITELN('If you know the wing area please input a 1. If you wish to have');
     WRITELN('the wing area calculated please input a 0.');
     READLN(X);
        IF X=1 THEN Answer:=TRUE ELSE Answer:=FALSE;
        IF Answer THEN
          BEGIN
          WRITE('Please input the wing area:');
          READLN(WA);
          END
        ELSE
           BEGIN
             WRITELN('This procedure will ask for a root chord and a tip chord.');
             WRITELN('Please input both even if your wing is constant chord.');
             WRITE('Root chord?');
             READLN(RootChord);
             WRITE('Tip chord?');
             READLN(TipChord);
             WRITE('Span?');
             READLN(Span);
             WA := ((TipChord + RootChord)/2)* Span;
            { WRITELN('The wing area is',WA:8:2, ' square inches.');}
           END;
    END;{WingArea}

PROCEDURE WingShape;

BEGIN
  WRITELN('Please select your wing type from the following list:');
  WRITELN(' 1 - Undercamber            3 - Semi-symmetrical ');
  WRITELN(' 2 - Flatbottom             4 - Symmetrical ');
  WRITE('Indicate choice:');
  READLN(WingType );
END;{WingType}

FUNCTION WL:REAL;{wingloading}

  BEGIN
  WL :=M/WA*144;
  END;{WL}

FUNCTION Z:REAL;{prop factor}

  BEGIN
  Z := (EXP(4*LN(D+3)))*(EXP(0.6*LN(D)))/4.23;
  END;{Z}


FUNCTION LF1:REAL;{Lift factor for undercamber}

CONST
  LF : REAL = 1.3;
  I  = 0.046;
VAR
  X,N : INTEGER;

BEGIN
X := Abs(ROUND(T-8));
  IF X = 0 THEN
  LF1 := LF ELSE
    BEGIN
      FOR N := 1 TO X DO
      LF := LF + I;
      LF1 := LF;
    END;{if}
END;{LF1}

FUNCTION LF2:REAL;{Lift factor for flatbottom}

CONST
  LF : REAL = 1.25;
  I  = 0.014;
VAR
  X,N : INTEGER;

BEGIN
X := Abs(ROUND(T-8));
  IF X = 0 THEN
  LF2 := LF ELSE
    BEGIN
      FOR N := 1 TO X DO
      LF := LF + I;
      LF2 := LF;
    END;{if}
END;{LF2}


FUNCTION LF3:REAL;{Lift factor for semi-symmetrical}

CONST
  LF : REAL = 1.05;
  I  = 0.02;
VAR
  X,N : INTEGER;

BEGIN
  X := Abs(ROUND(T-8));
  IF X = 0 THEN
  LF3 := LF ELSE
    BEGIN
      FOR N := 1 TO X DO
      LF := LF + I;
      LF3 := LF;
    END;{if}
END;{LF3}


FUNCTION LF4:REAL;{Lift factor for symmetrical}

CONST
  LF : REAL = 0.83;
  I  = 0.018;
VAR
  X,N : INTEGER;

BEGIN
X := Abs(ROUND(T-8));
  IF X = 0 THEN
  LF4 := LF ELSE
    BEGIN
      FOR N := 1 TO X DO
      LF := LF + I;
      LF4 := LF;
    END;{if}
END;{LF4}


FUNCTION AF:REAL;{altitude factor}

CONST
  AC:REAL = 830;

VAR
  X : REAL;
  N : INTEGER;

BEGIN
  X :=E/1000;
  IF X <= 0.5 THEN
  AF := AC ELSE
  BEGIN
    N :=0;
    REPEAT
    AC := AC*1.04;
    N := N + 1;
    UNTIL N = ROUND(X);
    AF := AC;
 END;{if}
END;{AF}

FUNCTION BM:REAL;

VAR
  X,Y,LF,A,B,C,D : REAL;


  BEGIN
    TY := WingType;
    A := LF1;
    B := LF2;
    C := LF3;
    D := LF4;
    IF TY =1 THEN
    LF := A ELSE
    IF TY =2 THEN
    LF := B ELSE
    IF TY =3 THEN
    LF := C ELSE
    IF TY =4 THEN
    LF := D;
    X := AF;
    Y := WL;
    BM := (X*M*(SQRT(Y/LF)));
  END;{BM}

FUNCTION TP:REAL;

VAR
   X : REAL;

  BEGIN
  X := Z;
  TP := X*P*R*R;
  END;


FUNCTION PF:REAL;{performance factor}

VAR
   X,Y : REAL;

  BEGIN
  X := TP;
  Y := BM;
  PF := X/Y;
  END;


PROCEDURE OutputData;

VAR
   Answer,Ans : INTEGER;
   HardCopy,Again : BOOLEAN;

   BEGIN
   Perf_Fac := PF;
   CLRSCR;
   WRITELN('                    Data for ',Name);
   WRITELN;
   WRITELN('The prop diameter is ',D:4:1,' and the pitch is ',P:3:1,'.');
   WRITELN('The propellor speed is ',R * 1000:5:0,' RPM.');
   WRITELN('The gross Take Off weight is ',M:5:1,' ounces.');
   WRITELN('The wing area is ',WA:6:2,' square inches or',WA/144:3:1,' square feet.');
   WRITELN('The wing loading is ',WL:3:1,' ounces per square foot.');
   WRITELN('The field elevation is ',E:5:0,' feet MSL.');
   WRITELN;
   WRITELN;
   WRITELN('The calculated performance factor is ',Perf_Fac:4:2,'.');
   WRITELN('Performance factors less than 25 indicate that the plane will not');
   WRITELN('fly. A PF between 25 and 35 indicates marginal performance. A factor');
   WRITELN('between 35 and 49 is rated as good, between 49 and 90 as super and');
   WRITELN('over 90 as overpowered.');
   WRITELN;
   WRITE('Do you want a hardcopy of this data? 0 = No, 1 = Yes');
   READLN(Answer);
       IF Answer = 1 THEN HardCopy := TRUE ELSE HardCopy := FALSE;
            IF HardCopy THEN
            BEGIN
               WRITELN(LST,'                    Data for ',Name);
               WRITELN(LST);
               WRITELN(LST,'The prop diameter is ',D:4:1,' and the pitch is ',P:3:1,'.');
               WRITELN(LST,'The propellor speed is ',R * 1000:5:0,' RPM.');
               WRITELN(LST,'The gross Take Off weight is ',M:5:1,' ounces.');
               WRITELN(LST,'The wing area is ',WA:6:2,' square inches or',WA/144:3:1,' square feet.');
               WRITELN(LST,'The wing loading is ',WL:3:1,' ounces per square foot.');
               WRITELN(LST,'The field elevation is ',E:5:0,' feet MSL.');
               WRITELN(LST);
               WRITELN(LST);
               WRITELN(LST,'The calculated performance factor is ',Perf_Fac:4:2,'.');
               WRITELN(LST,'Performance factors less than 25 indicate that the plane will not');
               WRITELN(LST,'fly. A PF between 25 and 35 indicates marginal performance. A factor');
               WRITELN(LST,'between 35 and 49 is rated as good, between 49 and 90 as super and');
               WRITELN(LST,'over 90 as overpowered.');
               END
             ELSE
             END;

PROCEDURE DoIt;

BEGIN
     Intro;
     GetData;
     Wingarea;
     WingShape;
     OutputData;
END;

PROCEDURE DoAgain;

VAR
   Answer : INTEGER;
   Again  : BOOLEAN;

BEGIN
     WRITELN;
     WRITE('Do you want to do another run? No = 0, Yes = 1');
     READLN(Answer);
     IF Answer = 1 THEN Again := TRUE ELSE Again := FALSE;
     IF Again THEN DoIt ELSE HALT;
END;

BEGIN
     DoIt;
     DoAgain;
END.

